#!/usr/bin/env perl6
use v6;

# Define the Grammar that matches Integers
my grammar checkInteger {
	rule TOP { 
		<integer>
	}
	token sign { <[+-]> }
	token decimal { \d+ }
	regex integer {
	    <sign>?
	    <decimal>+
	}
	regex isNumber {
		<sign>?
		<decimal>+
		"."
		<decimal>?
	}
	rule number {
		<isNumber>
	}
}

# Use the Grammar
my $input = "123.3";
if checkInteger.parse($input) {	say "$input is an integer"; }
else {	say "$input is not an integer!"  }
if checkInteger.parse($input, :rule<number> )
{ say "$input is a number!"; }
